//+------------------------------------------------------------------+
//|                                               Ind-Fractals-1.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 DarkBlue
#property indicator_color4 DarkBlue
#property indicator_color5 DarkGreen
#property indicator_color6 DarkGreen
#property indicator_color7 Black
#property indicator_color8 Black
//---- input parameters
extern bool      Comm=false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   ObjectsDeleteAll(0, OBJ_ARROW);   
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,234);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,2,1);
   SetIndexArrow(2,141);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW,2,1);
   SetIndexArrow(3,141);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW,2,2);
   SetIndexArrow(4,143);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW,2,2);
   SetIndexArrow(5,143);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW,2,2);
   SetIndexArrow(6,144);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW,2,2);
   SetIndexArrow(7,144);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  
//   ObjectDelete("T_m15");
//   ObjectDelete("T_m30");
//   ObjectDelete("T_h1");
//   ObjectDelete("T_h4");
//   ObjectDelete("T_d1");

   return(0);
  }
//------------------------------------------------------------------  
bool Fractal (string F,int Per, int shift)
  {
   if (Period()>Per) return(-1);
   Per=Per/Period()*2+MathCeil(Per/Period()/2);
   if (shift<Per)return(-1);
   if (shift>Bars-Per)return(-1); 
   for (int i=1;i<=Per;i++)
     {
      if (F=="U")
        {
         if (High[shift+i]>High[shift])return(-1);
         if (High[shift-i]>=High[shift])return(-1);     
        }
      if (F=="L")
        {
         if (Low[shift+i]<Low[shift])return(-1);
         if (Low[shift-i]<=Low[shift])return(-1);
        }        
     }
   return(1);   
  }  
//------------------------------------------------------------------
int start()
  {


   int D1=25, H4=15, H1=5, M15=1,B;
   double P;
//   int    counted_bars=IndicatorCounted();
   for( int i = MathMax(WindowFirstVisibleBar(), Bars-IndicatorCounted()); i>= 0; i--)
   B=Bars;
   if (Period()==D1)P=15*Point;
   if (Period()==H4)P=7*Point;
   if (Period()==H1)P=4*Point;
   if (Period()==30)P=3*Point;
   if (Period()==M15)P=2*Point;
   if (Period()==5)P=1*Point;
   if (Period()==1)P=0.5*Point;   
   for (int shift=B;shift>0;shift--)
      {
       if (Fractal("U",M15,shift)==1) ExtMapBuffer1[shift]=High[shift]+P;
       else ExtMapBuffer1[shift]=0;
       if (Fractal("L",M15,shift)==1) ExtMapBuffer2[shift]=Low[shift]-P;
       else ExtMapBuffer2[shift]=0;
       if (Fractal("U",H1,shift)==1) ExtMapBuffer3[shift]=High[shift]+P;
       else ExtMapBuffer3[shift]=0;
       if (Fractal("L",H1,shift)==1) ExtMapBuffer4[shift]=Low[shift]-P;
       else ExtMapBuffer4[shift]=0;
       if (Fractal("U",H4,shift)==1) ExtMapBuffer5[shift]=High[shift]+P;
       else ExtMapBuffer5[shift]=0;
       if (Fractal("L",H4,shift)==1) ExtMapBuffer6[shift]=Low[shift]-P;
       else ExtMapBuffer6[shift]=0;
       if (Fractal("U",D1,shift)==1) ExtMapBuffer7[shift]=High[shift]+P;
       else ExtMapBuffer7[shift]=0;
       if (Fractal("L",D1,shift)==1) ExtMapBuffer8[shift]=Low[shift]-P;
       else ExtMapBuffer8[shift]=0;
      }



//   if(ObjectFind("T_D1") != 0)
//   {
//        ObjectCreate("T_D1",OBJ_TEXT,0,Time[85],Close[0]+40*P);
//        ObjectSetText("T_D1","H4",9,"Arial Black",indicator_color8);
//   }
//   else
//   {
//      ObjectMove("T_D1",0,Time[85],Close[0]+40*P);
//   }


//   if(ObjectFind("T_H4") != 0)
//   {
//      ObjectCreate("T_H4",OBJ_TEXT,0,Time[82],Close[0]+40*P);
//      ObjectSetText("T_H4","H2",9,"Arial Black",indicator_color6);
//   }
//   else
//   {
//      ObjectMove("T_H4",0,Time[82],Close[0]+40*P);
//   }

 
// if(ObjectFind("T_H1") != 0)
//   {
//      ObjectCreate("T_H1",OBJ_TEXT,0,Time[79],Close[0]+40*P);
//      ObjectSetText("T_H1","H1",9,"Arial Black",indicator_color4);
//   }
//   else
//   {
//      ObjectMove("T_H1",0,Time[79],Close[0]+40*P);
 //  }
 
//  if(ObjectFind("T_M15") != 0)
//   {
//       ObjectCreate("T_M15",OBJ_TEXT,0,Time[75],Close[0]+40*P);
//         if(Period() > 59)
//            {
//            ObjectSetText("T_M15","H"+Period()/60,9,"Arial Black",indicator_color2);         
//            } 
//          else
//            {
//            ObjectSetText("T_M15","M"+Period(),9,"Arial Black",indicator_color2);

//ObjectSetText("T_M15","M15",9,"Arial Black",indicator_color2);
//             } 
//   }
//   else
//   {
//      ObjectMove("T_M15",0,Time[75],Close[0]+40*P);
//   }
 


   if (Comm) //Comment(" D1 - brown\n H4 - green\n H1 - blue\nM15 - red ");
   return(0);
  }
//+------------------------------------------------------------------+